<?php
if (!defined('ABSPATH')) {
    exit;
}

add_action('rest_api_init', function () {
    register_rest_route('api-post-grid/v1', '/posts', [
        'methods' => WP_REST_Server::READABLE,
        'callback' => 'api_post_grid_get_posts',
        'args' => [
            'category' => [
                'required' => false,
                'validate_callback' => function ($param) {
                    return is_string($param);
                },
            ],
            'taxonomy' => [
                'required' => false,
                'validate_callback' => function ($param) {
                    return is_string($param);
                },
            ],
            'post_type' => [
                'required' => false,
                'default' => 'post',
                'validate_callback' => function ($param) {
                    return post_type_exists($param);
                },
            ],
            'per_page' => [
                'required' => false,
                'default' => 12,
                'validate_callback' => function ($param) {
                    return is_numeric($param) && $param > 0;
                },
            ],
            'page' => [
                'required' => false,
                'default' => 1,
                'validate_callback' => function ($param) {
                    return is_numeric($param) && $param > 0;
                },
            ],
            'order' => [
                'required' => false,
                'default' => 'DESC',
                'validate_callback' => function ($param) {
                    return in_array(strtoupper($param), ['ASC', 'DESC']);
                },
            ],
            'orderby' => [
                'required' => false,
                'default' => 'date',
                'validate_callback' => function ($param) {
                    return is_string($param);
                },
            ],
        ],
        'permission_callback' => '__return_true',
    ]);
});